#!/usr/bin/env python

class C:
    def f(self):
        return 1

class D:
    def f(self):
        return 2

    def g(self):    # unused
        return 3

class E:
    def f(self):
        return 4

    def h(self):
        return 5

def test_new(obj):
    # obj: C, D, E (f)
    if obj.f():     # C, D, E (f)
        obj2 = D()  # obj2: E (h) -> conflict!
        obj2.h()    # E (h)
    # else:
    #   ...         # obj: C, D, E (f)
    #               # (f) ^ (f)
    return obj.f()  # C, D, E (f)

c = C()
d = D()
e = E()
result2_2 = test_new(c)

# vim: tabstop=4 expandtab shiftwidth=4
